#version 430 core
/*
* Shader for generating depth map for shadow mapping
*/

layout(location = 0) in vec3 position;
layout(location = 3) in ivec4 ids;
layout(location = 4) in vec4 weights;

uniform mat4 modelMatrix; //model matrix should be set per object that is loaded
uniform mat4 lightSpaceMatrix;
uniform mat4 pointLightSpaceMatrices[6];
uniform int type;

const int MAX_BONES = 40;
uniform mat4 bones[MAX_BONES];
uniform bool animation;

void main() {
    vec4 posAfterBone = vec4(position, 1.0);

	if (animation) {
		mat4 boneTransform = bones[ids[0]] *weights[0];
		boneTransform += bones[ids[1]] * weights[1];
		boneTransform += bones[ids[2]] * weights[2];
		boneTransform += bones[ids[3]] * weights[3];
		posAfterBone = boneTransform * vec4(position, 1.0);
	}
    if (type == 0) {
		gl_Position = lightSpaceMatrix * modelMatrix * posAfterBone;
	} else {
		gl_Position = modelMatrix * posAfterBone;
	}
}